<?php

/**
 * inf_can_prox_caus actions.
 *
 * @package    canon
 * @subpackage inf_can_prox_caus
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_pagos_plan_autoActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */
            $whereTitulo = ' ';
            if (isset($request['id_titulo'])) {
                $whereTitulo = " AND tab0.id_titulo = '" . $request['id_titulo'] . "' ";
            }
            
            $whereCompetencia = ' ';
            if (isset($request['id_competencia'])) {
                $whereCompetencia = " AND tab0.id_competencia = '" . $request['id_competencia'] . "' ";
            }
            
            $wherePlanilla = ' ';
            if (isset($request['id_liq_canon'])) {
                $wherePlanilla = " AND tab0.id_liq_canon = '" . $request['id_liq_canon'] . "' ";
            }
            
            $whereNoPagados = ' ';
            if (isset($request['sin_pago'])&& $request['sin_pago']=="true") {
                $whereNoPagados = " AND tab0.saldo_actual != 0";
            }
            
            $id_meses=$request['id_meses'];
            $id_anhos=$request['id_anhos'];

            $query="
select tab0.* from (
select liq.id_liq_canon, tit.cod_exp, tit.id_titulo, nc.descripcion as desc_norma, m.nombre as desc_modalidad,
ta.area/10000 as area_actual, ae.anualidad, e.nombre as desc_etapa, ae.fecha_inicio as fecha_inicio, 
ae.fecha_fin as fecha_fin, det.valor, sal.saldo_actual, cmp.nombre as desc_competencia, cmp.id_competencia
from ca_liq_canon liq
join ca_det_liq_canon det on liq.id_liq_canon = det.id_liq_canon and liq.vigencia = det.vigencia
join ca_anual_etapa ae on ae.id_anual_etapa = det.id_anual_etapa
join ca_titulo_etapa te on te.id_titulo_etapa = ae.id_titulo_etapa
join ca_etapa e on te.id_etapa = e.id_etapa
join rmn_titulo tit on det.id_titulo=tit.id_titulo
join ca_titulo_norma tn on det.id_titulo=tn.id_titulo and tn.actual=1
join ca_norma_canon nc on nc.id_norma = tn.id_norma
join rmn_titulo_modalidad tm on tm.id_titulo = det.id_titulo and tm.actual=1
join rmn_modalidad m on m.id_modalidad = tm.id_modalidad
join in_titulo_area ta on ta.id_titulo=det.id_titulo and ta.actual=1
join in_titulo_competencia tc on det.id_titulo = tc.id_titulo and tc.actual=1
join rmn_competencia cmp on tc.id_competencia = cmp.id_competencia
join ca_recibo rec on det.id_det_liq_canon=rec.id_det_liq_canon and det.vigencia = rec.vig_liq
join ca_recibo_debito rd on rd.id_recibo =  rec.id_recibo and rd.vigencia=rec.vigencia
join ca_debito@WEBSAFI debi on debi.id_debito=rd.id_debito 
join ca_saldos@WEBSAFI sal on rd.id_debito=sal.id_debito and sal.id_anhos=to_char(sysdate, 'yyyy') and sal.id_meses=to_char(sysdate, 'mm')
where liq.automatico=1 and liq.estado=0 and to_char(liq.fecha, 'YYYY') = $id_anhos and to_char(liq.fecha, 'MM') = $id_meses
--Liquidaciones aprobadas
and det.aprobado=1 and det.anulado=0
--ND activas
and debi.estado=1
)tab0
where 1=1
$wherePlanilla
$whereTitulo
$whereCompetencia
$whereNoPagados
";

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
$query      
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
$query     
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('ca_novedad_rev_tit');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                  //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INF_PAGOS_PLAN_AUTO] Consulta exitosa.");
            } else {

                $mensaje = "[INF_PAGOS_PLAN_AUTO] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error="[INF_PAGOS_PLAN_AUTO] ERROR: ". $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
